#####FUNÇÃO SELEÇÃO E LEITURA DE ARQUIVOS DE ÁUDIO#####

#Criar um objeto e importar um arquivo como os dados de data dos seus arquivos 
tabela<-read.table("S4A08400_A_Summary.txt", header=T, dec=".", sep=",")

#Selecionar apenas coluna de data
tabela.data<-tabela[,1]

#Arrumar a coluna DATE para deixar as linhas com formato adequado de data
tabela.data.a<-gsub("Jan",01,tabela.data) ###substitui Jan por mês=1
tabela.data.b<-gsub("Feb",02,tabela.data.a) ###substitui Feb por mês=2
tabela.data.c<-gsub("Mar",03,tabela.data.b) ###substitui Mar por mês=3
tabela.data.d<-gsub("Apr",04,tabela.data.c) ###substitui Apr por mês=4
tabela.data.e<-gsub("May",05,tabela.data.d) ###substitui May por mês=5
tabela.data.f<-gsub("Jun",06,tabela.data.e) ###substitui Jun por mês=6
tabela.data.g<-gsub("Jul",07,tabela.data.f) ###substitui Jul por mês=7
tabela.data.h<-gsub("Aug",08,tabela.data.g) ###substitui Ago por mês=8
tabela.data.i<-gsub("Sep",09,tabela.data.h) ###substitui Sep por mês=9
tabela.data.j<-gsub("Oct",10,tabela.data.i) ###substitui Oct por mês=10
tabela.data.k<-gsub("Nov",11,tabela.data.j) ###substitui Nov por mês=11
tabela<-gsub("Dec",12,tabela.data.k) ###substitui Dec por mês=12

#########INÍCIO DA FUNÇÃO##########

#Criar uma função chamada "select.arch" com os argumentos diretorio, diretorio2, "data.i", "data.f", "aleat"
select.arch<- function(diretorio, diretorio2, data.i=NULL, data.f=NULL, aleat=0, read.sound=F)
{
  setwd(diretorio) ###entra no diretorio de trabalho
  if (is.null(data.i)) ###se a data.i for nula, retorna uma mensagem
  {
    message ("Se você não definir uma data inicial, a função irá retornar desde o primeiro arquivo da sua pasta até o valor de data.f") ###mensagem para avisar sobre o que acontece caso a data.i for nula
  }
  if (is.null(data.f)) ###se data.f for nula, rertona uma mensagem
  {
    message ("Se você não definir uma data final, a função irá retornar desde o primeiro arquivo da sua data.i até arquivo final da pasta") ###mensagem para avisar sobre o que acontece caso a data.f for nula
  }
  
  if (aleat==0) ###se o usuário não colocar nenhum valor para o argumento aleat ou aleat for igual a 0, retorna mensagem 
  {
    message ("Todos os arquivos do da sequência de data serão retornados. Se você deseja apenas uma amostra, coloque o número de arquivos no argumento 'aleat'") ###mensagem para avisar o usuário o que acontecer caso aleat for igual a 0
  }
  if (read.sound==FALSE) ###se o usuário manter read.sound igual a FALSE, retorna mensagem
  {
    message ("Se você deseja ler os arquivos selecionados pela função, read.sound deve ser TRUE") ###mensagem para avisar o usuário sobre a leitura dos arquivos
  } 
  else ###se read.sound for igual a TRUE
  { 
    if (sum(rownames(installed.packages())=="seewave")==0) ###verifica se o paxcote seewave está instalado
    {
      install.packages("seewave") ###instala o pacote seewave
    }
    if (sum(rownames(installed.packages())=="sound")==0) ###verifica se o pacote sound está instalado
    {
      install.packages("sound") ###instala o pacote sound
    } 
    if (sum(rownames(installed.packages())=="audio")==0) ###verifica se o pacote audio está instalado
    {
      install.packages("audio") ###instala o pacote audio
    }
    if (sum(rownames(installed.packages())=="tuneR")==0) ###verifica se o pacote tuneR está instalado
    {
      install.packages("tuneR") ###instala o pacote tuner
    }
    require(seewave) ###a função irá carregar o pacote seewave
    require(sound) ###a função irá carregar o pacote seewave
    require(audio) ###a função irá carregar o pacote seewave
    require(tuneR) ###a função irá carregar o pacote seewave
  }
  tabela.final<-as.Date(tabela) ###transforma as datas da tabela no formato DATE
  if (class (tabela.final)!="Date") ###se a tabela não estiver no formato DATE
  {
    stop("Transforme sua coluna de data na classe DATE") ###a função para e avisa o usuário para transformar a coluna data na classe DATE
  }
  data.i<-as.Date(data.i, format="%Y-%m-%d") ###transforma o argumento data.i no formato DATE
  if (class(data.i)!= "Date") ###se data.i não for da classe data, a função para
  {
    stop("Use o formato %Y-%m-%d e transforme o vetor data na classe DATE") ###mensagem de aviso para o usuário transformar data.i na classe DATE
  }
  data.f<-as.Date(data.f, format="%Y-%m-%d") ###transforma o argumento data.f no formato DATE
  if (class(data.f)!= "Date") ###se data.f não for da classe data, a função para
  {
    stop("Use o formato %Y-%m-%d e transforme o vetor data na classe DATE") ###mensagem de aviso para o usuário transformar data.f na classe DATE
  }
  intervalo.data<-seq(from = as.Date(data.i), to = as.Date(data.f), by="day") ###criar uma sequência para incluir o intervalos entre data.i e data.f
  
  #Criar um objeto vazio para colocar o resultado do looping
  arquivos<-c()
  
  #Usar o looping para selecionar arquivos de interesse baseados na data 
  for(i in 1:length(tabela.final)) ###criar um contador que englobe todos os arquivos da tabela
  {
    for(j in 1:length(intervalo.data)) ###criar um contador que englobe os arquivos do intervalo de interesse
    {
      if(tabela.final[i]==intervalo.data[j]) ###procurar dentro do objeto todas as linhas que sejam da data.i
      {
        arquivos[i]<-i ###retornar os arquivos encontrados 
      }
    }
  }
  
  #Omitir os arquivos que não pertecem ao intervalo de interesse
  arquivos.sem.na<-na.omit(arquivos)
  
  #Listar os arquivos disponíveis no diretório
  lista.arquivos <- list.files(path=diretorio)
  
  #Arquivos por data
  final<-lista.arquivos[arquivos.sem.na]
  
  #Selecionar um número de arquivos aleatoriamente dentre os selecionados acima    
  
  if(aleat==0) ###usuário opta por não aleatorizar uma amostra dos arquivos
  {
    dir.create("arquivos_selecionados") ###cria a pasta "arquivos_selecionados" dentro do diretório de trabalho
    file.copy(from=final, to=diretorio2, copy.date=T) ###função copia todos os arquivos na pasta criada
    if(read.sound==T) ###se read.sound for TRUE, então os arquivos de áudio são lidos
    {
      for(i in 1:length(final))
      {
        f=22050 ###cria um objeto com a frequência do espectograma
        wave<-readWave(final[i]) ###cria o objeto wave e lê o arquivo de som 
        grafico<-spectro(wave,f) ###cria o espectograma do arquivo de som
        nome=paste(final[i] ,".jpg", sep="") ###cria o nome do arquivo 
        jpeg(nome) ###salva o arquivo de som em formato .jpeg 
      }
    }
  }
  if(aleat>=1) ###usuário opta por aleatorizar uma quantidade determinada dentre os arquivos selecionados
  {
    dir.create("arquivos_selecionados") ###cria a pasta "arquivos_selecionados" dentro do diretório de trabalho
    sorteio<-sample(final, size = aleat) ###sorteio dos arquivos
    file.copy(from=sorteio, to=diretorio2, copy.date=T) ######função copia os arquivos sorteados na pasta criada
    if(read.sound==T) ###se read.sound for TRUE, então os arquivos de áudio são lidos
    {
      for(i in 1:length(sorteio))
      {
        f=22050 ###cria um objeto com a frequencia do espectograma
        wave<-readWave(sorteio[i]) ###cria o objeto wave e lê o arquivo de som 
        grafico<-spectro(wave,f) ###cria o espectograma do arquivo de som
        nome = paste(sorteio[i] ,".jpg", sep = "") ###cria o nome do arquivo
        jpeg(nome) ###salva o arquivo de som em formato .jpeg 
      }
    }
  } 
  message ("Fique atento! Os argumentos 'data.i' e 'data.f' devem estar no formato AAAA-MM-DD") ###mensagem para avisar o usuário sobre o formato da data
  if(read.sound==F) ###se read.sound for FALSE
  {
    return("Os arquivos selecionados estão salvos no diretorio2")  ###informa onde estão os arquivos separados
  }
  else ###se read.sound for TRUE
  {
    return("Os arquivos selecionados estão salvos no diretorio2 e os espectogramas no diretorio(eles podem demorar para serem criados na pasta)")  ###informa onde estão os arquivos separados
  }
}  



